
#include "usart.h"
#include "debug.h"

u8 USART_Rbuffer_Num = 0;
u8 USART_Tbuffer_Num = 0;
u8 USART_Rbuffer[buffer_len];//ջ

void USARTx_Init(void)
{
    GPIO_InitTypeDef   GPIO_InitStructure={0};
    USART_InitTypeDef  USART_InitStructure={0};
    NVIC_InitTypeDef   NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4,ENABLE);

    /* USART2 TX-->PB0   RX-->PB1 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PB0Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PB1Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(UART4, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;      //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;           //ȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(UART4,USART_IT_RXNE,ENABLE);

    USART_Cmd(UART4,ENABLE);
}

void USARTx_SendByte(USART_TypeDef* pUSARTx, uint8_t data)
{
    USART_SendData(pUSARTx, data);
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
}

void USARTx_SendStr(USART_TypeDef* pUSARTx, char *str)
{
    uint8_t i = 0;
    do
    {
       USARTx_SendByte(pUSARTx, *(str+i));
       i++;
    }while(*(str+i) != '\0');
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TC) == RESET);
}

void UART4_IRQHandler(void)
{
    if(USART_GetITStatus(UART4, USART_IT_RXNE) != RESET) //жϲ
    {
        USART_ClearITPendingBit(UART4,USART_IT_RXNE);                //жϱ־
        USART_Rbuffer[USART_Rbuffer_Num] = USART_ReceiveData(UART4); //
        USART_Rbuffer_Num++;
    }

    for(USART_Tbuffer_Num=0;USART_Tbuffer_Num < USART_Rbuffer_Num;USART_Tbuffer_Num++)
    {
        USARTx_SendByte(UART4,USART_Rbuffer[USART_Tbuffer_Num]); //
    }

    USART_Rbuffer_Num = 0; //ʼ
    USART_Tbuffer_Num = 0;
}


